using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Drawing.Imaging;

namespace FrienDev.BusinessRules.ThumbnailHelper
{
    internal class ImageExtensionHelper
    {
        #region Public Methods
        /// <summary>
        /// ļжļͣļչ
        /// </summary>
        /// <param name="FileName">ļ</param>
        /// <returns>ļչ</returns>
        public static string GetFileTypeName(string fileName)
        {
            if (!CheckIsExistFileTypeName(fileName))
            {
                throw new ArgumentException("ļûչ");
            }

            //һ'.'ַ
            return Path.GetExtension(fileName).ToLower();
        }

        /// <summary>
        /// жǷϴļǷļ
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static bool CheckIsExistFileTypeName(string fileName)
        {
            if (fileName.LastIndexOf('.') > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// ֤Ƿ֧ļչ
        /// </summary>
        /// <param name="fileExt"></param>
        /// <returns></returns>
        public static bool ValidateSuppertFileType(string fileExt)
        {
            //صĽ
            bool result = false;
            //źϷչ
            foreach (string filetype in ImageDefinition.SupperFileTypes)
            {
                //ļչǷںϷͼƬ
                if (filetype.Equals(fileExt, StringComparison.OrdinalIgnoreCase))
                {
                    result = true;
                    break;
                }
            }
            return result;
        }

        /// <summary>
        /// õͼƬͶӦͼƬʽ͡
        /// </summary>
        /// <param name="fileType"></param>
        /// <returns></returns>
        public static ImageFormat GetSupportImageFormat(string fileType)
        {
            if (!ValidateSuppertFileType(fileType))
            {
                throw new Exception("ǰͼƬʽ֧");
            }
            return (ImageFormat)ImageDefinition.SupperImageFormatHashtable[fileType];
        }

        /// <summary>
        /// Դļļļʱ漴
        /// </summary>
        /// <param name="OriginalFileName">Դļ</param>
        /// <returns>µļ</returns>
        public static string CreateNewFileName(string fileType)
        {
            //ԭļлȡļչ
            string FileName = MakeRandomName() + fileType;
            return FileName;
        }

        public static void ValidateSavePathAndCreate(string fileSavePath)
        {
            if (!Directory.Exists(fileSavePath))
            {
                Directory.CreateDirectory(fileSavePath);
            }
        }
        #endregion

        #region Private Methods
        /// <summary>
        /// ʱļչ
        /// </summary>
        /// <returns>ļ</returns>
        private static string MakeRandomName()
        {
            string seedString = Guid.NewGuid().ToString();
            string[] seedStrings = seedString.Split('-');

            //int seed = Convert.ToInt32(seedStrings[3]);
            //Random dom = new Random(seed);
            //int RandomInt = dom.Next() % 1000;
            return System.DateTime.Now.ToString("yyyyMMddhhmmss") + seedStrings[4];
            //return System.DateTime.Now.ToString("yyyyMMddhhmmss") + DateTime.Now.Millisecond.ToString();
        }
        #endregion
    }
}
