using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;

namespace FrienDev.BusinessRules.ThumbnailHelper
{

    public class ThumbnailGenerater
    {
        #region Public Method


        /// <summary>
        /// ͼ
        /// </summary>
        /// <param name="sourceImagePath">ԭʼͼƬַ</param>
        /// <param name="thumbnailImagePath">ĿͼƬַ</param>
        /// <param name="thumbnailImageWidth">ͼ</param>
        /// <param name="thumbnailImageHeight">ͼ߶</param>
        /// <param name="sourceName">Դļ</param>
        /// <returns>ɵļ</returns>
        public static bool CreateNewThumbnailImage(string sourceImagePath
               , string sourceName
               , string thumbnailImagePath
               , string thumbnailImageName
               , int thumbnailImageWidth
               , int thumbnailImageHeight
               , string waterstring
               )
        {
            return CreateNewThumbnailImage(sourceImagePath
                 , sourceName
                 , thumbnailImagePath
                 , thumbnailImageName
                 , thumbnailImageWidth
                 , thumbnailImageHeight
                 , false, waterstring);
        }


        /// <summary>
        /// ͼ
        /// </summary>
        /// <param name="sourceImagePath">ԭʼͼƬַ</param>
        /// <param name="thumbnailImagePath">ĿͼƬַ</param>
        /// <param name="thumbnailImageWidth">ͼ</param>
        /// <param name="thumbnailImageHeight">ͼ߶</param>
        /// <param name="sourceName">Դļ</param>
        /// <returns>ɵļ</returns>
        public static bool CreateNewThumbnailImage(string sourceImagePath
                , string sourceName
                , string thumbnailImagePath
                , string thumbnailImageName
                , int thumbnailImageWidth
                , int thumbnailImageHeight
                , bool isUsedThumbnailImageHeight, string waterstring)
        {
            //õչơ
            string sExt = ImageExtensionHelper.GetFileTypeName(sourceName);
            string tExt = ImageExtensionHelper.GetFileTypeName(thumbnailImageName);

            // ԴͼƬ·ΪͼƬʽǷϷǷ򷵻ʧ
            if (string.IsNullOrEmpty(sourceImagePath) || string.IsNullOrEmpty(sourceName))
            {
                throw new ArgumentNullException("Դļ·ǿգ");
            }
            else
                if (!ImageExtensionHelper.ValidateSuppertFileType(sExt))
                {
                    throw new ArgumentException("ļͲ֧");
                }

            //жĿļǷϷǷ׳쳣
            if (string.IsNullOrEmpty(thumbnailImagePath) || string.IsNullOrEmpty(thumbnailImageName))
            {
                throw new ArgumentNullException("Ŀļ·ǿգ");
            }
            else
                if (!ImageExtensionHelper.ValidateSuppertFileType(tExt))
                {
                    throw new ArgumentException("ļͲ֧");
                }


            //ԭʼͼƬҺϷͼ
            //ԭͼƬImage

            string fullSourcePath = sourceImagePath + "\\" + sourceName;
            if (!File.Exists(fullSourcePath))
            {
                throw new ArgumentNullException("ԴַͼƬ");
            }
            System.Drawing.Image sourceImage = System.Drawing.Image.FromFile(fullSourcePath);

            //ԭͼƬȡ߶ȣԭͼƬ߱
            double originalWidth = sourceImage.Width;
            double originalHeight = sourceImage.Height;
            double originalRatio = originalWidth / originalHeight;

            //ͼҪĿ߱
            double thumbnailRatio = (double)thumbnailImageWidth / thumbnailImageHeight;

            //ͼͼ񲿷ֵĳ
            int picWidth;
            int picHeight;

            //ͼͼ񲿷ֵĿȡ߶ȡͼҪĿ߱Ȳߡ
            if (originalRatio > thumbnailRatio)
            {
                //ͼ߶Ȳ䣬صĿ
                picWidth = Convert.ToInt32(originalRatio * thumbnailImageHeight);
                picHeight = thumbnailImageHeight;
            }
            else
            {
                //ͼ߿Ȳ䣬صĸ߶
                picWidth = thumbnailImageWidth;
                picHeight = Convert.ToInt32(thumbnailImageWidth / originalRatio);
            }

            //ʹͼĸ
            if (!isUsedThumbnailImageHeight)
            {
                picHeight = Convert.ToInt32(thumbnailImageWidth * (originalHeight / originalWidth));
                thumbnailImageHeight = picHeight;
            }

            //õԭʼͼƬı
            ImageFormat imgFormat = ImageExtensionHelper.GetSupportImageFormat(tExt);
            //string fullthumbnailImagePath = thumbnailImagePath + thumbnailImageName;
            try
            {
                //ͼƬļ
                SaveImageToDisk(picWidth, picHeight
                    , thumbnailImageWidth, thumbnailImageHeight
                    , sourceImage, imgFormat
                    , thumbnailImagePath
                    , thumbnailImageName, waterstring, false);

            }
            catch (Exception e)
            {
                throw new Exception("ͼʧ", e);
            }
            finally
            {
                if (sourceImage != null)
                {
                    sourceImage.Dispose();
                }
            }

            return true;
        }

        public static bool CreateWatermarkImage(string inputString, string sourceImagePath
               , string sourceName
               , string thumbnailImagePath
               , string thumbnailImageName, string waterstring)
        {
            //õչơ
            string sExt = ImageExtensionHelper.GetFileTypeName(sourceName);
            string tExt = ImageExtensionHelper.GetFileTypeName(thumbnailImageName);

            // ԴͼƬ·ΪͼƬʽǷϷǷ򷵻ʧ
            if (string.IsNullOrEmpty(sourceImagePath) || string.IsNullOrEmpty(sourceName))
            {
                throw new ArgumentNullException("Դļ·ǿգ");
            }
            else
                if (!ImageExtensionHelper.ValidateSuppertFileType(sExt))
                {
                    throw new ArgumentException("ļͲ֧");
                }

            //жĿļǷϷǷ׳쳣
            if (string.IsNullOrEmpty(thumbnailImagePath) || string.IsNullOrEmpty(thumbnailImageName))
            {
                throw new ArgumentNullException("Ŀļ·ǿգ");
            }
            else
                if (!ImageExtensionHelper.ValidateSuppertFileType(tExt))
                {
                    throw new ArgumentException("ļͲ֧");
                }
            //ԭʼͼƬҺϷͼ
            //ԭͼƬImage

            string fullSourcePath = sourceImagePath + "\\" + sourceName;
            if (!File.Exists(fullSourcePath))
            {
                throw new ArgumentNullException("ԴַͼƬ");
            }
            System.Drawing.Image sourceImage = System.Drawing.Image.FromFile(fullSourcePath);

            int originalWidth = Convert.ToInt32(sourceImage.Width);
            int originalHeight = Convert.ToInt32(sourceImage.Height);


            //ʼ壬ͼƬϵλã뷽ʽ
            Font stringFont = new Font("Verdana", 12F,
                 System.Drawing.FontStyle.Regular,
                 System.Drawing.GraphicsUnit.Pixel,
                 ((byte)(134)));

            //Ͻ
            float xPoint = 10;
            float yPoint = 8;
            float xRight = 0;
            float yRight = 0;

            //
            StringFormat strFormat = new StringFormat();
            strFormat.Alignment = StringAlignment.Near;
            //ͼƬתΪͼ
            SizeF m_SizeF = new SizeF();


            //趨
            using (Graphics imgGraphics = Graphics.FromImage(sourceImage))
            {
                //ʼ

                m_SizeF = imgGraphics.MeasureString(waterstring, stringFont);

                xRight = sourceImage.Width - m_SizeF.Width - 10;
                yRight = sourceImage.Height - m_SizeF.Height - 8;

                imgGraphics.DrawString(inputString, stringFont, Brushes.Black, xPoint, yPoint, strFormat);
                imgGraphics.DrawString(inputString, stringFont, Brushes.White, xRight, yRight, strFormat);
            }

            ImageFormat imgFormat = ImageExtensionHelper.GetSupportImageFormat(tExt);

            try
            {
                //ͼƬļ
                SaveImageToDisk(originalWidth, originalHeight
                    , originalWidth, originalHeight
                    , sourceImage, imgFormat
                    , thumbnailImagePath
                    , thumbnailImageName, waterstring, true);
            }
            catch (Exception e)
            {
                throw new Exception("ͼʧ", e);
            }
            finally
            {
                if (sourceImage != null)
                {
                    sourceImage.Dispose();
                }
            }

            return true;
        }

        #endregion

        #region Private Method
        /// <summary>
        /// ͼ񵽴
        /// </summary>
        /// <param name="imageWidth">ͼ</param>
        /// <param name="imageHeight">ͼ߶</param>
        /// <param name="thumbnailImageWidth">ͼ</param>
        /// <param name="thumbnailImageHeight">ͼ߶</param>
        /// <param name="imagePath">·</param>
        /// <param name="sourceImage">ͼ</param>
        ///<param name="currentCoder">ͼ</param>
        /// <param name="thumbnailImagePath">ͼ񱣴·</param>
        /// <returns>ͼ񱣴Ƿɹ</returns>
        private static bool SaveImageToDisk(int imageWidth, int imageHeight
            , int thumbnailImageWidth, int thumbnailImageHeight
            , Image sourceImage, ImageFormat imageFormat, string thumbnailImagePath, string thumbnailImageName, string waterstring, bool isMark)
        {
            //شͼǷɹ
            bool result = false;
            Bitmap bitmap = null;
            Graphics graphics = null;
            try
            {
                //ָĴС͸ʽʼBitmapʵָĴСߴ
                bitmap = new Bitmap(thumbnailImageWidth, thumbnailImageHeight, PixelFormat.Format32bppArgb);
                //ָBitmap󴴽Graphics
                graphics = Graphics.FromImage(bitmap);

                //ͼ沢͸ɫ
                graphics.Clear(Color.Transparent);
                graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.High;
                graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;

                //ͼĻͼʼ
                int originleft = Convert.ToInt32((thumbnailImageWidth - imageWidth) / 2.0);
                int origintop = Convert.ToInt32((thumbnailImageHeight - imageHeight) / 2.0);

                //ָλòҰָСͼƬ
                graphics.DrawImage(sourceImage, new Rectangle(originleft, origintop, imageWidth, imageHeight));

                if (thumbnailImageWidth < 500)
                {
                    //ͼƬָʽָı浽ָļ	
                    SaveImage(bitmap, imageFormat, thumbnailImagePath, thumbnailImageName);
                }

                else if (isMark == true)
                {
                    SaveImage(bitmap, imageFormat, thumbnailImagePath, thumbnailImageName);
                }
                else
                {
                    Bitmap markedImage = (Bitmap)GenaraterWaterPrint(bitmap, waterstring, thumbnailImageWidth, thumbnailImageHeight);
                    //ͼƬָʽָı浽ָļ	
                    SaveImage(markedImage, imageFormat, thumbnailImagePath, thumbnailImageName);
                }

                //ɹ򷵻true
                result = true;

            }
            catch (Exception e)
            {
                throw new Exception("ܸļ", e);
            }
            finally
            {
                //ͷԴ
                if (bitmap != null)
                {
                    bitmap.Dispose();
                }

                if (graphics != null)
                {
                    graphics.Dispose();
                }
            }
            return result;
        }

        /// <summary>
        /// ͼƬ
        /// </summary>
        /// <param name="image">ͼƬ</param>
        /// <param name="savePath">·</param>
        /// <param name="ici">ָʽı</param>
        public static void SaveImage(System.Drawing.Image image, ImageFormat imgFormat
            , string thumbnailImagePath
            , string thumbnailImageName)
        {
            ImageExtensionHelper.ValidateSavePathAndCreate(thumbnailImagePath);

            string savePath = thumbnailImagePath + thumbnailImageName;
            //ļѴʱɾļ
            if (File.Exists(savePath))
            {
                File.SetAttributes(savePath, FileAttributes.Normal);
                File.Delete(savePath);
            }
            //savePath·°չ涨ıļ
            System.Drawing.Imaging.EncoderParameters encoderParams = new System.Drawing.Imaging.EncoderParameters();
            long[] quality = new long[1];
            quality[0] = 93;
            System.Drawing.Imaging.EncoderParameter encoderParam = new System.Drawing.Imaging.EncoderParameter(System.Drawing.Imaging.Encoder.Quality, quality);
            encoderParams.Param[0] = encoderParam;

            System.Drawing.Imaging.ImageCodecInfo[] arrayICI = System.Drawing.Imaging.ImageCodecInfo.GetImageEncoders();
            System.Drawing.Imaging.ImageCodecInfo jpegICI = null;
            for (int x = 0; x < arrayICI.Length; x++)
            {
                if (arrayICI[x].FormatDescription.Equals("JPEG"))
                {
                    jpegICI = arrayICI[x];
                    break;
                }
            }
            image.Save(savePath, jpegICI, encoderParams);
        }

        private static Image GenaraterWaterPrint(Bitmap thumbFile, string WaterString, int thumbnailImageWidth, int thumbnailImageHeight)
        {
            Image OriginalImg = (Image)thumbFile;


            //ʼ壬ͼƬϵλã뷽ʽ

            Font stringFont = new Font("Verdana", 12F,
                 System.Drawing.FontStyle.Regular,
                 System.Drawing.GraphicsUnit.Pixel,
                 ((byte)(134)));
            //Ͻ
            float xPoint = 10;
            float yPoint = 8;
            float xRight = 0;
            float yRight = 0;

            //
            StringFormat StrFormat = new StringFormat();
            StrFormat.Alignment = StringAlignment.Near;
            SizeF m_SizeF = new SizeF();


            // //ͼƬתΪͼ
            //Graphics OriginalPic = Graphics.FromImage(OriginalImg);

            //趨
            using (Graphics imgGraphics = Graphics.FromImage(OriginalImg))
            {
                //ʼ
                m_SizeF = imgGraphics.MeasureString(WaterString, stringFont);
                xRight = thumbnailImageWidth - m_SizeF.Width - 10;
                yRight = thumbnailImageHeight - m_SizeF.Height - 8;


                imgGraphics.DrawString(WaterString, stringFont, Brushes.Black, xPoint, yPoint, StrFormat);
                imgGraphics.DrawString(WaterString, stringFont, Brushes.White, xRight, yRight, StrFormat);
            }
            //תΪͼƬ
            //OriginalPic.DrawImage(OriginalImg, 0, 0);
            //OriginalPic.Dispose();
            return OriginalImg;
        }

        #endregion
    }

}
