﻿<%@ Application Language="C#" %>

<script RunAt="server">
    private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
    
    void Application_Start(object sender, EventArgs e)
    {
        // Code that runs on application startup
        // 配置log4net
        log4net.Config.XmlConfigurator.Configure();

        // 初始化应用程序池
        FrienDev.Api.FrienDevAppPool.Instance.SetApiHelper(FrienDev.BusinessRules.ApiHelper.Instance);
    }

    void Application_End(object sender, EventArgs e)
    {
        //  Code that runs on application shutdown

    }

    void Application_Error(object sender, EventArgs e)
    {
        // Code that runs when an unhandled error occurs
        Exception lastException = Server.GetLastError().GetBaseException();
        log.Fatal(lastException.Message, lastException);
        //Server.ClearError();
    }

    void Session_Start(object sender, EventArgs e)
    {
        // Code that runs when a new session is started
    }

    void Session_End(object sender, EventArgs e)
    {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.
        if (FrienDev.BusinessRules.UserRules.Instance.IsCurrentUserLogined)
        {
            FrienDev.BusinessRules.OnlineRules.Instance.UserLogout(FrienDev.BusinessRules.UserRules.Instance.GetCurrentUserId());
        }
        //SessionManager.OnLineFramework m_OnLineFramework = SessionManager.OnLineFramework.GetInstance();
        //if (Session.Contents["IP"] != null)
        //{
        //    m_OnLineFramework.Remove(Session.Contents["IP"].ToString());
        //}

    }
       
</script>

