﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using FrienDev.Data;
using FrienDev.BusinessRules;

public partial class Public_ActivityInvite : System.Web.UI.Page
{
    protected string AppId = ApplicationSettings.WindowsLiveLogin.AppId;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!string.IsNullOrEmpty(Request.QueryString["uid"]) && !string.IsNullOrEmpty(Request.QueryString["activityid"]))
        {
            string userId = Request.QueryString["uid"].Trim();
            int aid=Convert.ToInt32(Request.QueryString["activityid"]);
            Session.Add("ActivityID", aid);
            User user = UserRules.Instance.GetUserByUserId(userId);
            img_UserLogo.ImageUrl = ApiHelper.Instance.GetUserBigLogoUrl(user.UserId);
            Activity activity=ActivityRules.Instance.GetActivityInfo(aid);
            if (!string.IsNullOrEmpty(Request.QueryString["isreg"]))
            {
                Session.Add("IsInviteeRegisted", true);
                lb_Title.Text = user.FullName + "邀请您参加" + activity.Club.ClubName + "俱乐部的\"" + activity.ActivityName + "\"活动";
                lb_Tip.Text = "点击“登录网站”，登录后即可直接看到该活动详情";
            }
            else
            {
                lb_Title.Text = user.FullName + "邀请您参加" + activity.Club.ClubName + "俱乐部的\"" + activity.ActivityName + "\"活动";
                lb_Tip.Text = "该网站需要您使用LiveID进行登录注册，请点击“登陆网站”以进一步完成注册操作,，注册成功后，即可直接看到该活动详情";
            }
        }
    }
}
